## cupt 2.6.2

=== cpp/CMakeLists.txt ===
IF(EXISTS /usr/bin/g++-4.6)
	set(CMAKE_CXX_COMPILER /usr/bin/g++-4.6)
ELSE(EXISTS /usr/bin/g++-4.6)
	message(FATAL_ERROR "g++ 4.6.0 or greater required")
ENDIF(EXISTS /usr/bin/g++-4.6)

IF(NOT EXISTS /usr/include/boost/xpressive/xpressive_dynamic.hpp)
	message(FATAL_ERROR "missing Boost.Xpressive library")
ENDIF(NOT EXISTS /usr/include/boost/xpressive/xpressive_dynamic.hpp)

IF(NOT EXISTS /usr/include/boost/program_options.hpp)
	message(FATAL_ERROR "missing Boost.ProgramOptions library")
ENDIF(NOT EXISTS /usr/include/boost/program_options.hpp)

find_package(Boost 1.42.0)
IF(Boost_FOUND)
	IF(Boost_VERSION LESS 104200)
		message(FATAL_ERROR "need Boost of version 1.42.0")
	ENDIF(Boost_VERSION LESS 104200)
ELSE(Boost_FOUND)
	message(FATAL_ERROR "missing Boost")
ENDIF(Boost_FOUND)

IF(NOT EXISTS /usr/include/readline/readline.h)
	message(FATAL_ERROR "missing GNU Readline library")
ENDIF(NOT EXISTS /usr/include/readline/readline.h)

set(CMAKE_CXX_FLAGS "-ggdb -Wall -Wextra -std=gnu++0x -fPIC -I${CMAKE_SOURCE_DIR}/cpp/ -include common/common.hpp")

OPTION(VERBOSE "is build verbose")
IF(VERBOSE)
	set(CMAKE_VERBOSE_MAKEFILE TRUE)
ENDIF(VERBOSE)

OPTION(LOCAL "is build local" ON)
IF(LOCAL)
	set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DCUPT_LOCAL_BUILD")
ENDIF(LOCAL)

OPTION(OPTIMIZE "is build optimized")
IF(OPTIMIZE GREATER 0)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNDEBUG -O${OPTIMIZE}")
	IF(OPTIMIZE GREATER 1)
		# set(CMAKE_LD_FLAGS "${CMAKE_LD_FLAGS} -flto")
		# set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto")
	ENDIF(OPTIMIZE GREATER 1)
ENDIF(OPTIMIZE GREATER 0)

set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--as-needed")

set(CUPT_SOVERSION 0)

# detect version from debian/changelog
execute_process(
	COMMAND "dpkg-parsechangelog" "-l${PROJECT_SOURCE_DIR}/debian/changelog"
	COMMAND "grep" "^Version"
	COMMAND "cut" "-d " "-f" "2"
	OUTPUT_VARIABLE CUPT_VERSION
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

IF(CUPT_VERSION)
	message(STATUS "Detected Cupt version: ${CUPT_VERSION}")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DCUPT_VERSION=${CUPT_VERSION}")
ELSE(CUPT_VERSION)
	message(FATAL_ERROR "Unable to detect Cupt version.")
ENDIF(CUPT_VERSION)

include_directories(.)

add_subdirectory(console)
add_subdirectory(lib)
# add_subdirectory(precompiled)
add_subdirectory(downloadmethods)

=== debian/changelog ===
cupt (2.6.2) unstable; urgency=low

  * lib:
    - system/worker:
      - 'changeSystem': fixed forgetting some multiplied dependencies if some
        not changed installed packages has a dependency on some changed
        package through more than one relation expression. This regression
        was introduced in 2.2.0~rc1.
    - system/resolvers/native:
      - Reduced a memory footprint of unprepared solutions a bit.
  * debian:
    - control:
      - Bumped Standards-Version to 3.9.4, no changes needed.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 12 Oct 2013 17:51:10 +0300

cupt (2.6.1) experimental; urgency=low

  * debian:
    - cupt.manpages:
      - Fixed installing cupt_functionalselectors.7.
    - cupt.install:
      - Fixed installing all generated HTML pages.
    - rules:
      - Don't attempt to install logrotate script in binary-arch target. Fixes
        FTBFS for binary-only builds.
  * doc:
    - cmakelists:
      - Fixed installing all generated HTML pages to /usr/share, not only
        tutorial one.
      - Fixed not installing build artefacts of 'show-upgradeable' example.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 05 Oct 2013 15:57:19 +0300

cupt (2.6.0) experimental; urgency=low

  * console:
    - Managing packages:
      - The option 'cupt::resolver::track-reasons' does not correspond to the
        console '--show-reasons' option anymore.
      - New positional action override options '--markauto', '--unmarkauto',
        '--asauto=yes', '--asauto=no', '--asauto=default'.
      - 'markauto', 'unmarkauto': are now first-class management commands.
      - Action preview prompt: now properly show reinstalled packages as
        reinstalled, not as upgraded.
      - Action preview prompt: removed the 'one expression per line'
        limitation while processing 'a' choice.
      - Action preview prompt: new choice 'rc' ("show reason chain").
      - The option 'cupt::console::actions-preview::show-summary' got a new 
        value variant "auto".
      - Warn and require extra confirmation for actions on MultiArch-enabled
        systems. (Closes: #710052)
      - New positional request type options '--select=traditional',
        '--select=flexible'.
      - New positional request importance options '--importance=must',
        '--importance=try', '--importance=wish', '--importance=<value>'.
    - 'shell':
      - Don't rebuild the cache uselessly when a package management action
        was suggested but not confirmed by user.
    - New 'functional selectors' syntax for advanced version selection. 
    - 'search':
      - New option '--fse'.
    - 'tar-metadata':
      - Include also signatures of Release files.
    - 'show', 'showsrc': syntaxes '.../<distribution>' and '...=<version>' now
      work also with '-a' option.
  * lib:
    - Removed deprecated functions 'fatal', 'warn', 'debug', 'simulate'.
    - [API break] '__': now returns 'const char*' instead of 'string'.
    - cache:
      - [API break] Pointers to Package and Version objects are now persistent
        and unique. Thus shared pointers to those objects are no more used in
        public interfaces.
      - [API break] PinnedVersion: removed explicit constructor.
      - [API break] Removed deprecated methods and structures.
      - [API break] Constructor: removed the argument
        'packageNameGlobsToReinstall' as not needed anymore.
      - [API break] 'getLocalizedDescriptions' is replaced with
        'getLocalizedDescription'.
      - [API break] 'getPolicyVersion' is renamed to 'getPreferredVersion'.
      - New possibility to use index-of-index files to speed up building
        the package cache.
      - [API break] 'getSystemState': now returns persistent constant pointer.
      - Don't include unnecessary 'boost/xpressive/xpressive_fwd.hpp'.
        (Closes: #701207)
      - [ABI break] IndexEntry: new member 'options'.
      - Support for 'trusted=yes' and 'trusted=no' options in sources.list.
      - [API break] 'getBinaryPackageNames', 'getSourcePackageNames': return
        type is now 'Range<PackageNameIterator>'.
    - cache/package:
      - Apply id version suffixes (^<suffix>) to version strings to
        differentiate versions with same version string but different hash
        sums.
      - New methods begin() and end().
      - [API break]: 'addEntry': removed.
    - cache/relation:
      - [API break] ArchitecturedRelation, ArchitecturedRelationExpression:
        constructor from string subrange is now explicit.
      - [API break] Relation, ArchitecturedRelation: removed constructors from
        strings.
      - [API break] Use 'const char*' instead of 'string::const_iterator' in
        constructors.
    - config:
      - Don't store unused APT variables anymore.
      - New option 'cupt::console::actions-preview::show-reasons'.
      - New option 'cupt::update::generate-index-of-index'.
      - New option 'cupt::console::show-progress-messages'.
      - The option 'cupt::languages::indexes' has now default value
        'environment,en' to always download English translations regardless of
        the current locale.
      - Recognize and use the option 'dir::ignore-files-silently'.
        (Closes: #697248)
      - Removed the option 'cupt::update::keep-bad-signatures', signatures are
        always kept.
    - cache/version:
      - [API break] 'operator==': removed, versions can be now compared by
        pointers' values.
      - [API break] Source, InitializationParameters: replaced shared_ptr's
        with pointers.
      - [API break] InitializationParameters: removed.
    - system/resolver:
      - [API break] SuggestedPackage: new field 'automaticallyInstalledFlag',
        removed old field 'manuallySelected'.
      - New method 'setAutomaticallyInstalledFlag'.
      - 'SuggestedPackage': new field 'reasonPackageNames'.
      - [API break] 'unsatisfyRelationExpression': removed, merged into


=== debian/control ===
Source: cupt
Section: admin
Priority: optional
Build-Depends: debhelper (>= 7.4.10), g++-4.6,
  libboost-program-options-dev (>= 1.42), libboost-dev (>= 1.42),
  libreadline6-dev, chrpath, libcurl4-gnutls-dev (>= 7.19.4),
  cmake (>= 2.6), doxygen, libgcrypt11-dev, txt2tags, gettext
Maintainer: Cupt developers <cupt-devel@lists.alioth.debian.org>
Uploaders: Eugene V. Lyubimkin <jackyf@debian.org>
Homepage: http://wiki.debian.org/Cupt
Standards-Version: 3.9.4
Vcs-Git: git://github.com/jackyf/cupt.git
Vcs-Browser: https://github.com/jackyf/cupt/tree/master

Package: cupt-dbg
Section: debug
Priority: extra
Architecture: any
Depends: libcupt3-0 (= ${binary:Version}) | cupt (= ${binary:Version}) |
 libcupt3-0-downloadmethod-curl (= ${binary:Version}) |
 libcupt3-0-downloadmethod-wget (= ${binary:Version}),
 ${misc:Depends}
Description: alternative front-end for dpkg -- debugging symbols
 This package contains gdb debugging symbols for the Cupt packages.

Package: libcupt3-0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libcupt-common (>= ${source:Version})
Breaks: debdelta (<< 0.31)
Recommends: libcupt3-0-downloadmethod-curl | libcupt3-0-downloadmethod-wget, bzip2, gpgv, ed
Suggests: cupt, lzma, xz-utils, debdelta (>= 0.31), dpkg-dev, dpkg-repack
Description: alternative front-end for dpkg -- runtime library
 This is a Cupt library implementing front-end to dpkg.
 .
 Provides:
  - parsing and manipulating configuration info;
  - parsing indexes metadata info;
  - version strings comparison;
  - inspection of the binary and source package' versions;
  - parsing and querying info about installed packages;
  - parsing and working with relations and relation expressions;
  - download manager and downloaders for some schemes;
  - problem resolver;
  - worker for modifying system state.
 .
 See also description of 'cupt' package for more information.

Package: libcupt-common
Architecture: all
Depends: ${misc:Depends}
Conflicts: libcupt2-0
Replaces: libcupt2-0
Description: alternative front-end for dpkg -- runtime library (support files)
 This package provides architecture-independent support parts for Cupt library.
 .
 See also description of libcupt3-0 package.

Package: libcupt3-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libcupt3-0 (= ${binary:Version})
Conflicts: libcupt2-dev
Suggests: libcupt3-doc
Description: alternative front-end for dpkg -- development files
 This package provides headers for Cupt library.
 .
 See also description of libcupt3-0 package.

Package: libcupt3-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: alternative front-end for dpkg -- library documentation
 This package provides documentation for Cupt library.
 .
 See also description of libcupt3-0 package.

Package: cupt
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libcupt3-0 (>= ${binary:Version})
Breaks: daptup (<< 0.12.2~)
Suggests: sensible-utils, libreadline6
Description: alternative front-end for dpkg -- console interface
 This package provides a console interface to Cupt library, which is a
 re-implementation of libapt-pkg C++ library. The aim is to produce
 more strict, more robust, less buggy front-end than APT.
 .
 Cupt uses the same APT infrastructure, e.g. index files, deb cache archive
 files, configuration files. It understands some of widely used APT options.
 .
 Some features:
  - strict full-case resolver;
  - resolver reasons tracking;
  - command-line and 'cupt::*' option name checker;
  - case-sensitive search;
  - pinning by source package name;
  - pinning by package groups using shell-like patterns;
  - configurable 'depends' and 'rdepends' subcommands;
  - 'satisfy' subcommand;
  - support of LZMA-compressed indexes;
  - source versions synchronization;
  - 'shell' subcommand (to get command history, search etc. working, install
    the package 'libreadline6');
  - integration with debdelta (to get it, install the package 'debdelta');
  - system snapshots (needs packages 'dpkg-dev' and 'dpkg-repack').
 .
 Its interface is mostly like apt-get/aptitude console interface.
 .
 Cupt has built-in support for APT repositories using the file:// or copy://
 URL schemas. For access to remote repositories using HTTP or FTP, install a
 download method such as libcupt3-0-downloadmethod-curl.

Package: libcupt3-0-downloadmethod-curl
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: alternative front-end for dpkg -- libcurl download method
 This package provides http(s) and ftp download handlers for Cupt library
 using libcurl.
 .
 See also description of libcupt3-0 package.

Package: libcupt3-0-downloadmethod-wget
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, wget
Description: alternative front-end for dpkg -- wget download method
 This package provides http(s) and ftp download handlers for Cupt library
 using wget.
 .
 See also description of libcupt3-0 package.

=== debian/rules ===
#!/usr/bin/make -f

PERL ?= /usr/bin/perl
CMAKE_OPTIONS = -DLOCAL:bool=OFF
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CMAKE_OPTIONS += -DOPTIMIZE=0
else
	CMAKE_OPTIONS += -DOPTIMIZE=2
endif


override_dh_auto_configure:
	cmake -DCMAKE_INSTALL_PREFIX=$(CURDIR)/debian/tmp/usr $(CMAKE_OPTIONS) ./

override_dh_auto_install-arch:
	$(MAKE) install
	chrpath --delete $(CURDIR)/debian/tmp/usr/bin/cupt
	# produce additional man pages for cupt
	$(PERL) debian/install_pods
	install -m644 scripts/bash_completion $(CURDIR)/debian/cupt/etc/bash_completion.d/cupt

override_dh_auto_install-indep:
	install -m644 scripts/logrotate $(CURDIR)/debian/libcupt-common/etc/logrotate.d/cupt

override_dh_strip:
	dh_strip --dbg-package=cupt-dbg

%:
	dh --parallel $@

## cupt 2.6.3

=== debian/changelog ===
cupt (2.6.3) unstable; urgency=low

  * lib:
    - Standard-conformance fixes to be buildable by g++-4.8.
  * build system:
    - Removed the restriction to build only with g++-4.6.
  * debian:
    - control:
      - Removed 'g++-4.6' from Build-Depends.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 22 Oct 2013 23:05:55 +0300

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: cupt
 Section: admin
 Priority: optional
-Build-Depends: debhelper (>= 7.4.10), g++-4.6,
+Build-Depends: debhelper (>= 7.4.10),
   libboost-program-options-dev (>= 1.42), libboost-dev (>= 1.42),
   libreadline6-dev, chrpath, libcurl4-gnutls-dev (>= 7.19.4),
   cmake (>= 2.6), doxygen, libgcrypt11-dev, txt2tags, gettext

## cupt 2.6.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(Cupt)

add_subdirectory(cpp)
add_subdirectory(doc)
add_subdirectory(po)

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,3 @@
-IF(EXISTS /usr/bin/g++-4.6)
-	set(CMAKE_CXX_COMPILER /usr/bin/g++-4.6)
-ELSE(EXISTS /usr/bin/g++-4.6)
-	message(FATAL_ERROR "g++ 4.6.0 or greater required")
-ENDIF(EXISTS /usr/bin/g++-4.6)
-
 IF(NOT EXISTS /usr/include/boost/xpressive/xpressive_dynamic.hpp)
 	message(FATAL_ERROR "missing Boost.Xpressive library")
 ENDIF(NOT EXISTS /usr/include/boost/xpressive/xpressive_dynamic.hpp)

=== doc/CMakeLists.txt ===
IF(NOT EXISTS /usr/bin/doxygen)
	message(FATAL_ERROR "missing doxygen")
ENDIF(NOT EXISTS /usr/bin/doxygen)

IF(NOT EXISTS /usr/bin/txt2tags)
	message(FATAL_ERROR "missing txt2tags")
ENDIF(NOT EXISTS /usr/bin/txt2tags)

set(ODIR "${CMAKE_CURRENT_BINARY_DIR}")
set(DOXYGEN_OUTPUT_DIRECTORY "${ODIR}/reference")
add_custom_command(
	OUTPUT doxygen-stamp
	MAIN_DEPENDENCY "reference/Doxyfile"
	DEPENDS libcupt3
	WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/reference"

	COMMAND mkdir -p ${DOXYGEN_OUTPUT_DIRECTORY}
	COMMAND sh -c "( cat Doxyfile; echo \"OUTPUT_DIRECTORY=${DOXYGEN_OUTPUT_DIRECTORY}\" ) | doxygen -"
	COMMAND touch ${ODIR}/doxygen-stamp

	VERBATIM
)

MACRO(CUPT_PROCESS_T2T)
	FOREACH(_name ${ARGN})
		set(T2T_SOURCE "${CMAKE_CURRENT_SOURCE_DIR}/${_name}.t2t")
		set(HTML_FILE_NAME ${_name}.html)
		set(MAN_FILE_NAME cupt_${_name}.7)
		add_custom_command(
			MAIN_DEPENDENCY ${T2T_SOURCE}
			OUTPUT ${_name}-stamp

			COMMAND txt2tags ARGS -t html -o ${HTML_FILE_NAME} ${T2T_SOURCE}
			COMMAND txt2tags ARGS -t man -o ${MAN_FILE_NAME} ${T2T_SOURCE}
			COMMAND touch ${_name}-stamp
		)
		install(FILES ${ODIR}/${HTML_FILE_NAME} ${ODIR}/${MAN_FILE_NAME} DESTINATION share/doc)
	ENDFOREACH(_name)
ENDMACRO(CUPT_PROCESS_T2T)

CUPT_PROCESS_T2T(tutorial functionalselectors)

add_custom_target(doc ALL DEPENDS doxygen-stamp tutorial-stamp functionalselectors-stamp)

install(DIRECTORY examples DESTINATION share/doc/lib FILES_MATCHING PATTERN "*.cpp" PATTERN "*CMake*" EXCLUDE)
install(DIRECTORY ${ODIR}/reference/html DESTINATION share/doc/lib)
install(DIRECTORY ${ODIR}/reference/man DESTINATION share FILES_MATCHING PATTERN cupt*)

add_subdirectory(examples/show-upgradeable)

=== cpp/console/CMakeLists.txt ===
include_directories(../lib/include)
add_executable(cupt.bin
	common.cpp
	cupt.cpp
	misc.cpp
	handlers/search.cpp
	handlers/misc.cpp
	handlers/managepackages.cpp
	handlers/shell.cpp
	handlers/download.cpp
	handlers/snapshot.cpp
	colorizer.cpp
	functionselectors.cpp
	selectors.cpp)
set_property(TARGET cupt.bin PROPERTY OUTPUT_NAME cupt)
target_link_libraries(cupt.bin libcupt3 boost_program_options)

install(TARGETS cupt.bin DESTINATION bin)

=== cpp/downloadmethods/CMakeLists.txt ===
include_directories(../lib/include)

add_library(downloadmethod-wget MODULE wget.cpp)
set_property(TARGET downloadmethod-wget PROPERTY OUTPUT_NAME wget)
target_link_libraries(downloadmethod-wget libcupt3)

add_library(downloadmethod-curl MODULE curl.cpp)
set_property(TARGET downloadmethod-curl PROPERTY OUTPUT_NAME curl)
target_link_libraries(downloadmethod-curl libcupt3 curl-gnutls)

add_library(downloadmethod-debdelta MODULE debdelta.cpp)
set_property(TARGET downloadmethod-debdelta PROPERTY OUTPUT_NAME debdelta)
target_link_libraries(downloadmethod-debdelta libcupt3)

add_library(downloadmethod-file MODULE file.cpp)
set_property(TARGET downloadmethod-file PROPERTY OUTPUT_NAME file)
target_link_libraries(downloadmethod-file libcupt3)

install(TARGETS downloadmethod-file downloadmethod-wget downloadmethod-curl downloadmethod-debdelta
		DESTINATION lib/cupt3-${CUPT_SOVERSION}/downloadmethods)

=== cpp/lib/CMakeLists.txt ===
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DSOVERSION=${CUPT_SOVERSION} -fvisibility=hidden")

include_directories(include)
include_directories(src)
add_library(libcupt3 SHARED
	./src/internal/common.cpp
	./src/internal/configparser.cpp
	./src/internal/nativeresolver/impl.cpp
	./src/internal/nativeresolver/solution.cpp
	./src/internal/nativeresolver/score.cpp
	./src/internal/nativeresolver/dependencygraph.cpp
	./src/internal/nativeresolver/decisionfailtree.cpp
	./src/internal/nativeresolver/autoremovalpossibility.cpp
	./src/internal/lock.cpp
	./src/internal/cacheimpl.cpp
	./src/internal/pininfo.cpp
	./src/internal/filesystem.cpp
	./src/internal/debdeltahelper.cpp
	./src/internal/tagparser.cpp
	./src/internal/worker/base.cpp
	./src/internal/worker/archives.cpp
	./src/internal/worker/dpkg.cpp
	./src/internal/worker/metadata.cpp
	./src/internal/worker/setupandpreview.cpp
	./src/internal/worker/packages.cpp
	./src/internal/worker/snapshots.cpp
	./src/internal/regex.cpp
	./src/internal/cachefiles.cpp
	./src/internal/logger.cpp
	./src/internal/pipe.cpp
	./src/internal/basepackageiterator.cpp
	./src/internal/indexofindex.cpp
	./src/internal/versionparse.cpp
	./src/config.cpp
	./src/cache.cpp
	./src/cache/relation.cpp
	./src/cache/binarypackage.cpp
	./src/cache/binaryversion.cpp
	./src/cache/sourcepackage.cpp
	./src/cache/sourceversion.cpp
	./src/cache/package.cpp
	./src/cache/version.cpp
	./src/system/state.cpp
	./src/system/resolver.cpp
	./src/system/resolvers/native.cpp
	./src/system/worker.cpp
	./src/system/snapshots.cpp
	./src/download/uri.cpp
	./src/download/manager.cpp
	./src/download/method.cpp
	./src/download/methodfactory.cpp
	./src/download/progress.cpp
	./src/download/progresses/console.cpp
	./src/common.cpp
	./src/common/compareversions.cpp
	./src/common/consumers.cpp
	./src/file.cpp
	./src/hashsums.cpp
	./src/versionstring.cpp
)
set_target_properties(libcupt3 PROPERTIES SOVERSION ${CUPT_SOVERSION} OUTPUT_NAME cupt3)
target_link_libraries(libcupt3 dl rt gcrypt)

install(TARGETS libcupt3 DESTINATION lib)
install(DIRECTORY include/ DESTINATION include)

=== doc/examples/show-upgradeable/CMakeLists.txt ===
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -std=c++0x")
include_directories(../../../cpp/lib/include)
add_executable(show-upgradeable show-upgradeable.cpp)
target_link_libraries(show-upgradeable libcupt3)

=== debian/changelog ===
cupt (2.6.4) unstable; urgency=medium

  * lib:
    - system/worker:
      - 'renameSnapshot': don't accept invalid snapshot names.
      - Detect snapshot names having whitespace characters as invalid.
      - 'updateReleaseAndIndexData': reimplemented needed subset of <future>.
        Fixes FTBFS on armel. (Closes: #730974)
  * debian:
    - control:
      - Bumped Standards-Version to 3.9.5, no changes needed.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Tue, 24 Dec 2013 20:59:30 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 Maintainer: Cupt developers <cupt-devel@lists.alioth.debian.org>
 Uploaders: Eugene V. Lyubimkin <jackyf@debian.org>
 Homepage: http://wiki.debian.org/Cupt
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Vcs-Git: git://github.com/jackyf/cupt.git
 Vcs-Browser: https://github.com/jackyf/cupt/tree/master

## cupt 2.8.2ubuntu1

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,7 @@
 	message(FATAL_ERROR "missing GNU Readline library")
 ENDIF(NOT EXISTS /usr/include/readline/readline.h)
 
-set(CMAKE_CXX_FLAGS "-ggdb -Wall -Wextra -std=gnu++0x -fPIC -I${CMAKE_SOURCE_DIR}/cpp/ -include common/common.hpp")
+set(CMAKE_CXX_FLAGS "-pthread -ggdb -Wall -Wextra -std=gnu++0x -fPIC -I${CMAKE_SOURCE_DIR}/cpp/ -include common/common.hpp")
 
 OPTION(VERBOSE "is build verbose")
 IF(VERBOSE)
@@ -35,13 +35,13 @@
 IF(OPTIMIZE GREATER 0)
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNDEBUG -O${OPTIMIZE}")
 	IF(OPTIMIZE GREATER 1)
-		# set(CMAKE_LD_FLAGS "${CMAKE_LD_FLAGS} -flto")
-		# set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto")
+		# set(CMAKE_LD_FLAGS "${CMAKE_LD_FLAGS} -flto -ffat-lto-objects")
+		# set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto -ffat-lto-objects")
 	ENDIF(OPTIMIZE GREATER 1)
 ENDIF(OPTIMIZE GREATER 0)
 
-set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed")
-set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--as-needed")
+set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pthread -Wl,--as-needed")
+set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -pthread -Wl,--as-needed")
 
 set(CUPT_SOVERSION 0)

=== debian/changelog ===
cupt (2.8.2ubuntu1) utopic; urgency=medium

  * Build using -pthread.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Sep 2014 16:31:20 +0200

cupt (2.8.2) unstable; urgency=medium

  * test:
    - cmakelists:
      - Avoided trying symlinking a directory to itself for in-tree builds.
        Makes building succeed with CMake 3.0. (Closes: #758446)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Wed, 20 Aug 2014 22:12:47 +0300

cupt (2.8.1) unstable; urgency=medium

  * lib,console:
    - Used more explicit syntax for initialization of some STL structures.
      Fixes builds with g++-4.9. (Closes: #746840)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 11 May 2014 16:33:18 +0300

cupt (2.8.0) experimental; urgency=low

  * lib:
    - system/resolvers/native:
      - 'upgrade': re-implemented in terms of 'satisfyRelationExpression'.
    - cache:
      - 'getSatisfyingVersions': minimal single-arch support for ':any'
        suffixes.
    - cache/relation:
      - Constructor: reject package names starting with an allowed symbol.
    - 'consumePackageName': allow ':' character.
  * test:
    - Introduced.
  * debian:
    - libcupt3-0.shlibs: bumped to 2.8.0~.
    - control: modified short and long descriptions to stress flexibility.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Fri, 02 May 2014 18:31:24 +0300

cupt (2.7.3) unstable; urgency=low

  * lib:
    - system/resolvers/native:
      - Fixed failing to satisfy 'remove x --no-remove'-kinds of requests.
        This regression was introduced in 2.6.0.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Fri, 18 Apr 2014 17:41:29 +0300

cupt (2.7.2) unstable; urgency=low

  * lib:
    - system/resolvers/native:
      - Branch filtering heuristics: fixed skipping sticked but satisfying
        elements. This could lead to skipping some valid solutions.
        This regression was introduced in 2.7.0.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Wed, 05 Mar 2014 21:05:37 +0200

cupt (2.7.1) unstable; urgency=low

  * lib:
    - config:
      - 'setScalar': for options from foreign families, save also their
        normalized form if it's recognized/used. This regression was
        introduced in 2.7.0. (Closes: #740141)
  * doc:
    - news:
      - Filled for 2.7.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 01 Mar 2014 11:47:46 +0200

cupt (2.7.0) unstable; urgency=low

  * lib:
    - Fixed not invoking std::terminate() when a pipe process fail.
    - config:
      - New option 'cupt::directory::configuration::pre'.
      - 'setScalar': accept options from foreign families. They may be useful
        for e.g. hooks.
      - Option 'cupt::resolver::max-solution-count': increased default value
        from 512 to 8192.
    - system/resolvers/native:
      - Reduced solution memory footprint.
      - Reduced average CPU costs of postprocessing failed solutions.
      - Apply some more heuristics to reject new solution tree branches early,
        leading to from neglective/significant/major speed-ups depending on
        the problem patterns.
    - system/worker:
      - 'changeSystem': for removal actions, change automatically installed
        flag after the action, not before.
      - 'changeSystem': support VERSION 3 of preinstall hooks. Thanks to
         James McCoy for the format analysis.
      - 'changeSystem': support for sending hook input to any file descriptor
        hooks want. Thanks to James McCoy for the report. Together with an
        entry above this (Closes: 725979)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 22 Feb 2014 15:51:56 +0200

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,8 @@
 else
 	CMAKE_OPTIONS += -DOPTIMIZE=2
 endif
+
+CMAKE_OPTIONS += -DVERBOSE:bool=ON
 
 
 override_dh_auto_configure:

## cupt 2.8.4

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -35,13 +35,14 @@
 IF(OPTIMIZE GREATER 0)
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNDEBUG -O${OPTIMIZE}")
 	IF(OPTIMIZE GREATER 1)
-		# set(CMAKE_LD_FLAGS "${CMAKE_LD_FLAGS} -flto -ffat-lto-objects")
-		# set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto -ffat-lto-objects")
+		# set(CMAKE_LD_FLAGS "${CMAKE_LD_FLAGS} -flto")
+		# set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -flto")
 	ENDIF(OPTIMIZE GREATER 1)
 ENDIF(OPTIMIZE GREATER 0)
 
-set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pthread -Wl,--as-needed")
-set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -pthread -Wl,--as-needed")
+set(OUR_LINKER_FLAGS "-pthread -Wl,--as-needed")
+set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OUR_LINKER_FLAGS}")
+set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${OUR_LINKER_FLAGS}")
 
 set(CUPT_SOVERSION 0)

=== test/CMakeLists.txt ===
set(SDIR ${CMAKE_CURRENT_SOURCE_DIR})
add_custom_target(
	test
	COMMAND cmake -E create_symlink ${SDIR}/t tt
	COMMAND ${SDIR}/run.sh ${SDIR} $<TARGET_FILE:cupt.bin>
)

=== debian/changelog ===
cupt (2.8.4) unstable; urgency=medium

  * lib:
    - system/worker:
      - 'changeSystem': preinstall hooks: pass original version strings of
        installed versions, not id-suffixed ones. (Closes: #764754)
    - cache:
      - Version pinning: fixed matching version strings of installed versions.
        (Closes: #764238)
    - system/resolvers/native:
      - Reverted 'fixed failing to satisfy 'remove x --no-remove'-kinds of
        requests', so 'no-remove' option works again for any kind of user
        requests. This now includes explicit ones as well, so
        'remove x --no-remove' are now expected to fail if 'x' is manually
        installed package. The regression was introduced in 2.7.3.
  * cmakelists:
    - Added '-pthread' to compiling and linking flags. (Closes: #760489)

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sun, 19 Oct 2014 20:50:23 +0300

cupt (2.8.3) unstable; urgency=medium

  * lib:
    - config:
      - New option 'cupt::console::actions-preview::show-empty-versions'.
    - system/resolvers/native:
      - For equal-scored version change variants, propose higher versions
        first. The regression for some typical upgrade situations was
        introduced in 2.8.0, the regression for some typical non-upgrade
        user requests was introduced in 2.6.0, and many non-typical cases
        probably never worked before.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Sat, 04 Oct 2014 12:52:34 +0300

=== debian/control ===
--- 
+++ 
@@ -20,7 +20,7 @@
  libcupt3-0-downloadmethod-curl (= ${binary:Version}) |
  libcupt3-0-downloadmethod-wget (= ${binary:Version}),
  ${misc:Depends}
-Description: alternative front-end for dpkg -- debugging symbols
+Description: flexible package manager -- debugging symbols
  This package contains gdb debugging symbols for the Cupt packages.
 
 Package: libcupt3-0
@@ -29,8 +29,10 @@
 Breaks: debdelta (<< 0.31)
 Recommends: libcupt3-0-downloadmethod-curl | libcupt3-0-downloadmethod-wget, bzip2, gpgv, ed
 Suggests: cupt, lzma, xz-utils, debdelta (>= 0.31), dpkg-dev, dpkg-repack
-Description: alternative front-end for dpkg -- runtime library
- This is a Cupt library implementing front-end to dpkg.
+Description: flexible package manager -- runtime library
+ This is a Cupt library implementing high-level package manager for Debian and
+ derivatives. It's written with flexibility and reliability in mind and uses
+ dpkg as the back-end.
  .
  Provides:
   - parsing and manipulating configuration info;
@@ -50,7 +52,7 @@
 Depends: ${misc:Depends}
 Conflicts: libcupt2-0
 Replaces: libcupt2-0
-Description: alternative front-end for dpkg -- runtime library (support files)
+Description: flexible package manager -- runtime library (support files)
  This package provides architecture-independent support parts for Cupt library.
  .
  See also description of libcupt3-0 package.
@@ -61,7 +63,7 @@
 Depends: ${misc:Depends}, libcupt3-0 (= ${binary:Version})
 Conflicts: libcupt2-dev
 Suggests: libcupt3-doc
-Description: alternative front-end for dpkg -- development files
+Description: flexible package manager -- development files
  This package provides headers for Cupt library.
  .
  See also description of libcupt3-0 package.
@@ -70,7 +72,7 @@
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
-Description: alternative front-end for dpkg -- library documentation
+Description: flexible package manager -- library documentation
  This package provides documentation for Cupt library.
  .
  See also description of libcupt3-0 package.
@@ -80,10 +82,10 @@
 Depends: ${misc:Depends}, ${shlibs:Depends}, libcupt3-0 (>= ${binary:Version})
 Breaks: daptup (<< 0.12.2~)
 Suggests: sensible-utils, libreadline6
-Description: alternative front-end for dpkg -- console interface
- This package provides a console interface to Cupt library, which is a
- re-implementation of libapt-pkg C++ library. The aim is to produce
- more strict, more robust, less buggy front-end than APT.
+Description: flexible package manager -- console interface
+ This package provides a console interface to Cupt library, which implements
+ high-level package manager for Debian and derivatives. Cupt is written with
+ flexibility and reliability in mind and uses dpkg as the back-end.
  .
  Cupt uses the same APT infrastructure, e.g. index files, deb cache archive
  files, configuration files. It understands some of widely used APT options.
@@ -113,7 +115,7 @@
 Package: libcupt3-0-downloadmethod-curl
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: alternative front-end for dpkg -- libcurl download method
+Description: flexible package manager -- libcurl download method
  This package provides http(s) and ftp download handlers for Cupt library
  using libcurl.
  .
@@ -122,7 +124,7 @@
 Package: libcupt3-0-downloadmethod-wget
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}, wget
-Description: alternative front-end for dpkg -- wget download method
+Description: flexible package manager -- wget download method
  This package provides http(s) and ftp download handlers for Cupt library
  using wget.
  .

## cupt 2.9.1

=== cpp/CMakeLists.txt ===
IF(NOT EXISTS /usr/include/boost/xpressive/xpressive_dynamic.hpp)
	message(FATAL_ERROR "missing Boost.Xpressive library")
ENDIF()

IF(NOT EXISTS /usr/include/boost/program_options.hpp)
	message(FATAL_ERROR "missing Boost.ProgramOptions library")
ENDIF()

find_package(Boost 1.42.0)
IF(Boost_FOUND)
	IF(Boost_VERSION LESS 104200)
		message(FATAL_ERROR "need Boost of version 1.42.0")
	ENDIF(Boost_VERSION LESS 104200)
ELSE()
	message(FATAL_ERROR "missing Boost")
ENDIF()

IF(NOT EXISTS /usr/include/readline/readline.h)
	message(FATAL_ERROR "missing GNU Readline library")
ENDIF()

set(CMAKE_CXX_FLAGS "-pthread -Wall -Wextra -std=gnu++0x -fPIC -I${CMAKE_SOURCE_DIR}/cpp/ -include common/common.hpp")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-format-security") # yes, we should move type-safe alternative eventually
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} $ENV{CXXFLAGS}")

OPTION(LOCAL "is build local" ON)


set(OUR_LINKER_FLAGS "-pthread -Wl,--as-needed")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OUR_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${OUR_LINKER_FLAGS}")

set(CUPT_API_VERSION 4)
set(CUPT_SOVERSION 0)
set(CUPT_RELATIVE_DOWNLOADMETHODS_DIR "lib/cupt${CUPT_API_VERSION}-${CUPT_SOVERSION}/downloadmethods")

# detect version from debian/changelog
execute_process(
	COMMAND "dpkg-parsechangelog" "-l${PROJECT_SOURCE_DIR}/debian/changelog"
	COMMAND "grep" "^Version"
	COMMAND "cut" "-d " "-f" "2"
	OUTPUT_VARIABLE CUPT_VERSION
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

IF(CUPT_VERSION)
	message(STATUS "Detected Cupt version: ${CUPT_VERSION}")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DCUPT_VERSION=${CUPT_VERSION}")
ELSE()
	message(FATAL_ERROR "Unable to detect Cupt version.")
ENDIF()

include_directories(.)

add_subdirectory(console)
add_subdirectory(lib)
add_subdirectory(downloadmethods)

=== debian/changelog ===
cupt (2.9.1) unstable; urgency=medium

  * lib:
    - cmakelists:
      - Pass absolute path of 'downloadmethods' directory for local builds.
        Makes downloading work when locally built cupt binary is called from
        non-usual locations.
  * test:
    - TestCupt:
      - Made the regex parsing 'cupt policy' output stricter. This reduces
        the probability of false negatives.

 -- Eugene V. Lyubimkin <jackyf@debian.org>  Fri, 17 Jul 2015 08:32:43 +0300

cupt (2.9.0) experimental; urgency=low

  * console:
    - 'functional selectors':
      - Fixed crashing when non-first argument to and() contains package
        relationship or defining functions.
      - New function 'source-to-binary'.
    - 'search':
      - FSE mode: enabled parsing of unknown version fields.
    - 'why':
      - Prefer any number of (Pre-)Depends over 1 Recommends.
      - Prefer 2 Recommends over 1 Suggests.
      - Apply penalties for non-first relations. (Closes: #772558)
    - 'snapshot save':
      - Accept only snapshot names made of whitelist characters (lowercase
        latin letters, digits, dash, underscore).
    - Version selecting:
      - Fixed '<package>=<version>' syntax for versions with id suffixes.
  * lib:
    - Bumped API version to 4.
    - config:
      - New option 'cupt::resolver::score::version-factor::common'.
      - New option 'cupt::resolver::score::version-factor::negative'.
      - New option
        'cupt::resolver::score::version-factor::priority-downgrade'.
        (Closes: #764755)
      - New option 'cupt::resolver::max-leaf-count'.
      - Option 'cupt::resolver::max-solution-count': increased default value
        from 8192 to 32000.
      - Option 'cupt::resolver::score::quality-adjustment': changed default
        value from 40 to 0.
      - Option 'cupt::resolver::score::removal-of-autoinstalled': changed
        default value from 1200 to 1500.
      - Option 'cupt::resolver::score::upgrade': changed default value
        from 100 to 20.
      - 'setScalar': when doing APT-to-Cupt option translation, also-set
        original-case APT option instead of normalised-case APT option.
      - 'setScalar': accept any option from 'dpkg' family without filtering.
    - system/state:
      - [API break] 'getInstalledInfo': returns raw pointer.
      - [ABI break] Removed handling of longly obsolete Status fields. Patch by
        Guillem Jover. (Closes: #764468)
      - InstalledRecord::Status::strings: added strings for trigger-related
        states. Fixes crash on trying to stringify such states.
    - system/worker:
      - [API break] 'setAutomaticallyInstalledFlag': removed as obsolete.
      - Debdelta helper: use debdelta sources file path as relative to 'dir'
        option, not as absolute path.
      - 'changeSystem': preinstall hooks: pass original version strings of
        supposed versions, not id-suffixed ones.
      - 'changeSystem': preinstall hooks v3: pass '-' instead of empty string
        as architecture for purged versions.
      - 'changeSystem': dpkg commands: run '--triggers-only --pending' even if
        trigger deferring is switched off (see #766758 for discussion).
      - 'changeSystem': preserve unknown fields when writing to extended
        states file.
      - 'changeSystem': preinstall hook: if an input is supplied, don't hang
        if the hook does not accept it all.
    - system/resolvers/native:
      - Removed the version normalized score calculation skew.
        (Closes: #754480, #622939)
      - Implemented automatic quality adjustment.
      - Fixed not applying downgrade score for reinstalls. This regression
        was introduced in 2.6.0.
      - Significantly reduced not-user score part of upgrades.
      - For equal-scored version change variants (when replacing a version
        because of a broken relation), propose higher versions first.
    - versionstring:
      - [API break] 'getOriginal': return StringRange.
      - [API break] 'sameOriginal': removed as obsolete.
      - [API break] 'getOriginal': moved out of 'versionstring' namespace.
    - cache/binaryversion:
      - [API break] 'provides': are now versioned.
    - common:
      - 'checkVersionString': accept underscores (with warnings) again. This
        regression was introduced in 2.0.0~alpha1.
      - [API break] 'checkVersionString', 'compareVersionStrings': moved to
        'versionstring' header.
      - [API break] 'checkPackageName', 'consumePackageName': moved to
        'packagename' header.
      - [API break] 'checkPackageName': first parameter's type is now
        StringRange.
    - cache/relation:
      - [ABI break] Relation: new member 'architecture'.
    - cache:
      - [API break] PinnedVersion: renamed to VersionWithPriority.
      - [API break] 'getSortedPinnedVersions': renamed to
        getSortedVersionsWithPriorities.
      - Parsing extended states: don't choke on records without
        'Auto-Installed' field.
      - [ABI break] ExtendedInfo: new member 'raw'.
    - system/snapshots:
      - 'setupResolverForSnapshotOnly': don't reinstall equal versions.
        The regression was introduced in 2.6.0.
    - cache/package:
      - [API break] Constructor: removed 'binaryArchitecture' parameter.
  * doc:
    - cmakelists:
      - Added rules building man pages from PODs.
    - examples:
      - Added 'show-available' example.
    - reference:
      - Removed timestamps from documentation. Makes builds reproducible.
        Patch by Chris Lamb. (Closes: #777576)
      - Explicitly remove all Javascript files generated by Doxygen, they are
        not actually used but some versions of Doxygen keep generating them.
    - news:
      - Moved to actual 'doc' directory.
  * debian:
    - control:
      - Added 'Breaks: dpkg (<< 1.17.11~)' for versioned provides support.
      - Bumped Standards-Version to 3.9.6, no changes needed.
    - rules:
      - Enabled dh_auto_configure's build system autodetection.


=== debian/control ===
--- 
+++ 
@@ -1,14 +1,27 @@
 Source: cupt
 Section: admin
 Priority: optional
-Build-Depends: debhelper (>= 7.4.10),
-  libboost-program-options-dev (>= 1.42), libboost-dev (>= 1.42),
-  libreadline6-dev, chrpath, libcurl4-gnutls-dev (>= 7.19.4),
-  cmake (>= 2.6), doxygen, libgcrypt11-dev, txt2tags, gettext
+Build-Depends:
+# build system
+  debhelper (>= 7.4.10),
+  cmake (>= 2.6),
+  chrpath,
+  gettext,
+# runtime libraries
+  libboost-program-options-dev (>= 1.42),
+  libboost-dev (>= 1.42),
+  libreadline6-dev,
+  libcurl4-gnutls-dev (>= 7.19.4),
+  libgcrypt11-dev,
+# documentation
+  doxygen,
+  txt2tags,
+# test suite
+  libipc-run3-perl
 Maintainer: Cupt developers <cupt-devel@lists.alioth.debian.org>
 Uploaders: Eugene V. Lyubimkin <jackyf@debian.org>
 Homepage: http://wiki.debian.org/Cupt
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Vcs-Git: git://github.com/jackyf/cupt.git
 Vcs-Browser: https://github.com/jackyf/cupt/tree/master
 
@@ -16,18 +29,18 @@
 Section: debug
 Priority: extra
 Architecture: any
-Depends: libcupt3-0 (= ${binary:Version}) | cupt (= ${binary:Version}) |
- libcupt3-0-downloadmethod-curl (= ${binary:Version}) |
- libcupt3-0-downloadmethod-wget (= ${binary:Version}),
+Depends: libcupt4-0 (= ${binary:Version}) | cupt (= ${binary:Version}) |
+ libcupt4-0-downloadmethod-curl (= ${binary:Version}) |
+ libcupt4-0-downloadmethod-wget (= ${binary:Version}),
  ${misc:Depends}
 Description: flexible package manager -- debugging symbols
  This package contains gdb debugging symbols for the Cupt packages.
 
-Package: libcupt3-0
+Package: libcupt4-0
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}, libcupt-common (>= ${source:Version})
-Breaks: debdelta (<< 0.31)
-Recommends: libcupt3-0-downloadmethod-curl | libcupt3-0-downloadmethod-wget, bzip2, gpgv, ed
+Breaks: debdelta (<< 0.31), dpkg (<< 1.17.11~)
+Recommends: libcupt4-0-downloadmethod-curl | libcupt4-0-downloadmethod-wget, bzip2, gpgv, ed
 Suggests: cupt, lzma, xz-utils, debdelta (>= 0.31), dpkg-dev, dpkg-repack
 Description: flexible package manager -- runtime library
  This is a Cupt library implementing high-level package manager for Debian and
@@ -55,31 +68,31 @@
 Description: flexible package manager -- runtime library (support files)
  This package provides architecture-independent support parts for Cupt library.
  .
- See also description of libcupt3-0 package.
+ See also description of libcupt4-0 package.
 
-Package: libcupt3-dev
+Package: libcupt4-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, libcupt3-0 (= ${binary:Version})
+Depends: ${misc:Depends}, libcupt4-0 (= ${binary:Version})
 Conflicts: libcupt2-dev
-Suggests: libcupt3-doc
+Suggests: libcupt4-doc
 Description: flexible package manager -- development files
  This package provides headers for Cupt library.
  .
- See also description of libcupt3-0 package.
+ See also description of libcupt4-0 package.
 
-Package: libcupt3-doc
+Package: libcupt4-doc
 Section: doc
 Architecture: all
 Depends: ${misc:Depends}
 Description: flexible package manager -- library documentation
  This package provides documentation for Cupt library.
  .
- See also description of libcupt3-0 package.
+ See also description of libcupt4-0 package.
 
 Package: cupt
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libcupt3-0 (>= ${binary:Version})
+Depends: ${misc:Depends}, ${shlibs:Depends}, libcupt4-0 (>= ${binary:Version})
 Breaks: daptup (<< 0.12.2~)
 Suggests: sensible-utils, libreadline6
 Description: flexible package manager -- console interface
@@ -110,22 +123,22 @@
  .
  Cupt has built-in support for APT repositories using the file:// or copy://
  URL schemas. For access to remote repositories using HTTP or FTP, install a
- download method such as libcupt3-0-downloadmethod-curl.
+ download method such as libcupt4-0-downloadmethod-curl.
 
-Package: libcupt3-0-downloadmethod-curl
+Package: libcupt4-0-downloadmethod-curl
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: flexible package manager -- libcurl download method
  This package provides http(s) and ftp download handlers for Cupt library
  using libcurl.
  .
- See also description of libcupt3-0 package.
+ See also description of libcupt4-0 package.
 
-Package: libcupt3-0-downloadmethod-wget
+Package: libcupt4-0-downloadmethod-wget
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}, wget
 Description: flexible package manager -- wget download method
  This package provides http(s) and ftp download handlers for Cupt library
  using wget.
  .
- See also description of libcupt3-0 package.
+ See also description of libcupt4-0 package.

=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CMAKE_OPTIONS += -DCMAKE_BUILD_TYPE=RelWithDebInfo
else
	CMAKE_OPTIONS += -DCMAKE_BUILD_TYPE=Debug
endif


override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTIONS)

override_dh_auto_install-arch:
	dh_auto_configure -- $(CMAKE_OPTIONS) -DLOCAL:bool=off
	dh_auto_install
	chrpath --delete $(CURDIR)/debian/tmp/usr/bin/cupt
	install -m644 scripts/bash_completion $(CURDIR)/debian/cupt/etc/bash_completion.d/cupt

override_dh_auto_install-indep:
	install -m644 scripts/logrotate $(CURDIR)/debian/libcupt-common/etc/logrotate.d/cupt

override_dh_strip:
	dh_strip --dbg-package=cupt-dbg

%:
	dh --parallel $@
